=== modified file 'src/com/goldencode/p2j/persist/AbstractTempTable.java'
--- src/com/goldencode/p2j/persist/AbstractTempTable.java	2022-05-31 19:11:54 +0000
+++ src/com/goldencode/p2j/persist/AbstractTempTable.java	2022-11-11 09:09:20 +0000
@@ -56,6 +56,7 @@
 **     CA  20220920 Buffer implicit deletion performed on temp-table delete must use a ProcedureManager to 
 **                  delete it instead of handle.delete.
 **     IAS 20221003 Fixed error message for error 3131
+**     IAS 20221111 Added setter for the 'schemaMarshalLevel', fixed one for the 'namespaceURI'.
 */
 
 /*
@@ -882,6 +883,15 @@
    }
    
    /**
+    * Set the current {@code SCHEMA-MARSHAL} level. Refer to {@code SM_DEFAULT}, {@code SM_NONE},
+    * {@code SM_MIN}, and {@code SM_FULL} static constants for details. 
+    */
+   public void setSchemaMarshalLevel(int schemaMarshalLevel)
+   {
+      this.schemaMarshal = schemaMarshalLevel;
+   }
+
+   /**
     * Implements the {@code NO-SCHEMA-MARSHAL} attribute getter.
     * 
     * @return  {@code true} when {@code SCHEMA-MARSHAL} attribute is set to {@code "NONE"}.
@@ -2314,7 +2324,7 @@
    @Override
    public void namespaceURI(character uri)
    {
-      namespaceURI(uri.toJavaType());
+      namespaceURI(uri.isUnknown() ? "" : uri.toJavaType());
    }
    
    /**

=== modified file 'src/com/goldencode/p2j/persist/DataSet.java'
--- src/com/goldencode/p2j/persist/DataSet.java	2022-10-31 12:20:33 +0000
+++ src/com/goldencode/p2j/persist/DataSet.java	2022-11-11 15:04:56 +0000
@@ -92,6 +92,7 @@
 **                  an APPEND option.
 **     CA  20220918 Automatically delete top-nav queries created dynamically by the DATASET.
 **     CA  20221031 Added JMX instrumentation for DATASET[-HANDLE] parameter processing.
+**     IAS 20221108 Fixed support for SCHEMA-MARSHAL == NONE.
 */
 
 /*
@@ -151,6 +152,7 @@
 
 import com.goldencode.p2j.jmx.*;
 import com.goldencode.p2j.persist.TemporaryBuffer.CopyTableMode;
+import com.goldencode.p2j.persist.orm.*;
 import com.goldencode.p2j.persist.serial.*;
 import com.goldencode.p2j.security.*;
 import com.goldencode.p2j.util.*;
@@ -673,6 +675,15 @@
                   wrapper = dsSrc.getDatasetWrapper().getTableWrapper(k - 1);
                }
                
+               if (dsSrc.isRemoteParameter()  && !wrapper.isReceivedSchema())
+               {
+                  RecordBuffer rb = ((BufferReference) targetDmo).buffer();
+                  DmoMeta meta = rb.getDmoInfo();
+                  Iterator<Property> props = meta.getFields(false);
+                  List<PropertyDefinition> pdl = new ArrayList<>();
+                  props.forEachRemaining(p -> pdl.add(new PropertyDefinition(p)));
+                  wrapper.setProperties(pdl);
+               }
                TemporaryBuffer.insertAllRows(
                      wrapper,
                      (Temporary) targetDmo,
@@ -851,6 +862,14 @@
          {
             if (dsParam.isByReference() || dsParam.isRemoteParameter())
             {
+               // check if all tables contain schema.
+               if (!dsParam.getDatasetWrapper().getTableDefs().stream().
+                        allMatch(DsTableDefinition::isReceivedSchema))
+               {
+                  // A NO-SCHEMA-MARSHAL table cannot be used as a parameter where the receiving side
+                  // does not have a pre-prepared schema
+                  ErrorManager.recordOrThrowError(12323);
+               }
                // if [dsParam] is remote, the dataset was rehydrated when [dsParam] was created
                // do not copy now for 2nd time. Since it is an [input] param we can use the 
                // dataset handle directly.
@@ -2347,7 +2366,7 @@
    @Override
    public void namespaceURI(character uri)
    {
-      namespaceURI(uri.toJavaType());
+      namespaceURI(uri == null & uri.isUnknown() ? "" : uri.toJavaType());
    }
    
    /**
@@ -3899,6 +3918,10 @@
       List<BufferImpl> localBuffers = new ArrayList<>(bufs.length);
       for (Buffer buf : bufs)
       {
+         if (buf == null)
+         {
+            continue;
+         }
          BufferImpl bufRef = ((BufferImpl) buf).ref();
          if (initClass == null)
          {

=== modified file 'src/com/goldencode/p2j/persist/DataSetContainer.java'
--- src/com/goldencode/p2j/persist/DataSetContainer.java	2021-07-01 10:04:17 +0000
+++ src/com/goldencode/p2j/persist/DataSetContainer.java	2022-11-11 09:10:40 +0000
@@ -2,7 +2,7 @@
 ** Module   : DataSetContainer.java
 ** Abstract : A container used to serialize a dataset and send it to a remote side. 
 **
-** Copyright (c) 2019-2021, Golden Code Development Corporation.
+** Copyright (c) 2019-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description----------------------------------
 ** 001 OM  20190708 Created initial version.
@@ -10,6 +10,7 @@
 **     CA  20190812 Added toString().
 ** 002 SVL 20210614 Added copyRows parameter.
 **     SVL 20210701 Added clearRows.
+** 003 IAS 20221111 Added 'xmlNodeName', 'nsURI', and 'nsPrefix' fields. 
 */
 
 /*
@@ -92,6 +93,15 @@
    /** The definitions for all relations between the tables in the dataset. */
    private List<DsRelationDefinition> relationDefinitions = null;
    
+   /** The XML namespace for this dataset. */
+   private String xmlns = null;
+   
+   /** The XML prefix for this dataset. */
+   private String xmlPrefix = null;
+   
+   /** The XML-NODE-NAME attribute for this dataset. */
+   private String xmlNodeName = null;
+
    /**
     * Default c'tor, explicitly added to allow instances of this class to be created on 
     * deserialization. Not for public use.
@@ -257,6 +267,13 @@
       
       setStructureName(ds.name().toStringMessage());
       
+      character tmp = ds.namespaceURI();
+      this.xmlns = tmp.isUnknown() ? "" : tmp.toJavaType();
+      tmp = ds.namespacePrefix();
+      this.xmlPrefix = ds.namespacePrefix().toJavaType(); 
+      tmp = ds.getXmlNodeName();
+      this.xmlNodeName = ds.getXmlNodeName().toJavaType();
+      
       // prepare relation data
       int relCnt = ds.getNumRelations().intValue();
       relationDefinitions = new ArrayList<>(relCnt);
@@ -276,6 +293,33 @@
    }
 
    /**
+    * Get the XML namespace of the DATASET.
+    * @return XML namespace of the DATASET
+    */
+   public String namespaceURI()
+   {
+      return xmlns;
+   }
+
+   /**
+    * Get the XML prefix of the DATASET.
+    * @return XML prefix of the DATASET
+    */
+   public String namespacePrefix()
+   {
+      return xmlPrefix;
+   }
+
+   /**
+    * Get the XML node name of the DATASET.
+    * @return XML node name of the DATASET
+    */
+   public String getXmlNodeName()
+   {
+      return xmlNodeName;
+   }
+
+   /**
     * Delete row data.
     */
    public void clearRows()

=== modified file 'src/com/goldencode/p2j/persist/DataSetParameter.java'
--- src/com/goldencode/p2j/persist/DataSetParameter.java	2022-07-27 08:56:51 +0000
+++ src/com/goldencode/p2j/persist/DataSetParameter.java	2022-11-11 09:17:33 +0000
@@ -39,6 +39,9 @@
 **                  INPUT-OUTPUT mode, and the DATASET-HANDLE, DATASET, TABLE-HANDLE or TABLE versions.
 **     CA  20220727 Fixed OO dataset/table parameters (at the method definition and method call) when there is
 **                  an APPEND option.
+**     IAS 20221108 Fixed support for SCHEMA-MARSHAL == NONE. Re-worked indexes (de)serialization.
+**     IAS 20221111 Fixed support of relations' for SCHEMA-MARSHAL == NONE and issues with 
+**                  processing 'schemaMarshalLevel', 'xmlNodeName', 'nsURI', and 'nsPrefix'. 
 */
 
 /*
@@ -324,6 +327,7 @@
    {
       BufferManager.registerScopeable(null);
       
+      this.originalDataSet = (DataSet)dsHandle.getResource();
       this.dataset = dsHandle;
       this.options = options; // TODO: check default value for mode if ParameterOption.NONE is passed in
       this.input   = input;
@@ -533,22 +537,42 @@
       DataSet.create(dataset);
       DataSet newDS = (DataSet) dataset.getResource();
       newDS.name(wrapper.getDatasetName());
+      newDS.namespaceURI(wrapper.namespaceURI());
+      newDS.namespacePrefix(wrapper.namespacePrefix());
+      newDS.setXmlNodeName(wrapper.getXmlNodeName());
       
       List<DsTableDefinition> tableDefs = wrapper.getTableDefs();
+      Set<String> tablesWithoutSchema = new HashSet<>();
       if (tableDefs != null && !tableDefs.isEmpty())
       {
          BufferImpl[] buffs = new BufferImpl[tableDefs.size()];
          for (int k = 0; k < tableDefs.size(); k++)
          {
             DsTableDefinition tableDef = tableDefs.get(k);
-            
+            if (!tableDef.isReceivedSchema())
+            {
+               tablesWithoutSchema.add(tableDef.getName());
+               continue;
+            }
             if (!tableDef.isBeforeTable())
             {
                Iterator<PropertyDefinition> props = tableDef.propertyIterator();
                String idx = tableDef.getIndexes();
                String xmlns = tableDef.getXmlns();
                String prefix = tableDef.getXmlPrefix();
-               buffs[k] = TempTableBuilder.createRemoteTable(tableDef.getName(), props, idx, xmlns, prefix);
+               List<IndexDefinition> indexDefs = tableDef.getIndexDefs();
+               TempTableBuilder ttb = new TempTableBuilder(); 
+               if (indexDefs != null)
+               {
+                  buffs[k] = ttb.createRemoteTable(tableDef.getName(), 
+                           props, () -> indexDefs.stream().forEach(ix -> ix.addTo(ttb)), 
+                           xmlns, prefix, tableDef.getSchemaMarshalLevel());
+               }
+               else
+               {
+                  buffs[k] = ttb.createRemoteTable(tableDef.getName(), 
+                           props, idx, xmlns, prefix, tableDef.getSchemaMarshalLevel());
+               }
                
                if (tableDef.isAfterTable() && tableDef.getPeerDef() != null)
                {
@@ -574,6 +598,11 @@
       {
          for (DsRelationDefinition relDef : relationsDefs)
          {
+            if (tablesWithoutSchema.contains(relDef.getParentBuffer()) ||
+                tablesWithoutSchema.contains(relDef.getChildBuffer()))
+            {
+               continue;
+            }
             handle hRel = newDS.addRelation(
                   newDS.bufferHandle(relDef.getParentBuffer()),
                   newDS.bufferHandle(relDef.getChildBuffer()),

=== modified file 'src/com/goldencode/p2j/persist/DatasetWrapper.java'
--- src/com/goldencode/p2j/persist/DatasetWrapper.java	2022-11-02 18:21:56 +0000
+++ src/com/goldencode/p2j/persist/DatasetWrapper.java	2022-11-11 09:20:49 +0000
@@ -17,8 +17,9 @@
 **                  (so that relations, schema, etc is done on the server-side).
 **     CA  20221102 Added a static serialization ID - required when enabling AOP method tracing (see 
 **                  p2j.aspects.ltw.MethodTraceAspect).
-*/
-
+**     IAS 20221108 Fixed support for SCHEMA-MARSHAL == NONE.
+**     IAS 20221111 Added 'xmlNodeName', 'nsURI', and 'nsPrefix' fields and fixed 
+**                  'schemaMarshalLevel' support.
 /*
 ** This program is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU Affero General Public License as
@@ -121,6 +122,15 @@
    /** The name of the DataSet. */
    private String dsName = null;
    
+   /** The XML namespace for this dataset. */
+   private String xmlns = null;
+   
+   /** The XML prefix for this dataset. */
+   private String xmlPrefix = null;
+   
+   /** The XML-NODE-NAME attribute for this dataset. */
+   private String xmlNodeName = null;
+
    /** Flag indicating if the source is a JSON dataset. */
    private boolean fromJson;
    
@@ -172,6 +182,9 @@
    public DatasetWrapper(DataSetContainer resource)
    {
       this.resource = resource;
+      this.xmlns = resource.namespaceURI();
+      this.xmlPrefix = resource.namespacePrefix();
+      this.xmlNodeName = resource.getXmlNodeName();
    }
 
    /**
@@ -184,7 +197,7 @@
     */
    public DatasetWrapper(boolean fromJson, DataSetContainer resource)
    {
-      this.resource = resource;
+      this(resource);
       this.fromJson = fromJson;
    }
    
@@ -260,6 +273,33 @@
    {
       return resource;
    }
+
+   /**
+    * Get the XML namespace of the DATASET.
+    * @return XML namespace of the DATASET
+    */
+   public String namespaceURI()
+   {
+      return xmlns;
+   }
+
+   /**
+    * Get the XML prefix of the DATASET.
+    * @return XML prefix of the DATASET
+    */
+   public String namespacePrefix()
+   {
+      return xmlPrefix;
+   }
+
+   /**
+    * Get the XML node name of the DATASET.
+    * @return XML node name of the DATASET
+    */
+   public String getXmlNodeName()
+   {
+      return xmlNodeName;
+   }
    
    /**
     * Returns the list of table definitions for the temp-tables from this {@code DataSet}.
@@ -437,6 +477,9 @@
 
          writeString(out, dsName);
       }
+      writeString(out, xmlns);
+      writeString(out, xmlPrefix);
+      writeString(out, xmlNodeName);
       
       // write properties
       if (resource != null)
@@ -504,6 +547,9 @@
       }
       
       dsName = readString(in);
+      xmlns = readString(in);
+      xmlPrefix = readString(in);
+      xmlNodeName = readString(in);
       
       int n = in.readInt(); 
       if (n != 0)
@@ -566,13 +612,14 @@
       {
          TableWrapper tw = new TableWrapper(fromJson, res);
          tw.setTableName(tdef.getName());
+         tw.setSchemaMarshalLevel(tdef.getSchemaMarshalLevel());
          ByteArrayOutputStream baos = new ByteArrayOutputStream();
          ObjectOutputStream oos = new ObjectOutputStream(baos);
          tw.writeExternal(oos);
          oos.close();
          tw = new TableWrapper();
          tw.readExternal(new ObjectInputStream(new ByteArrayInputStream(baos.toByteArray())));
-         
+         tw.receivedSchema = tdef.receivedSchema;
          if (bres != null)
          {
             TableWrapper btw = new TableWrapper(bres);

=== modified file 'src/com/goldencode/p2j/persist/DsTableDefinition.java'
--- src/com/goldencode/p2j/persist/DsTableDefinition.java	2021-07-01 10:04:17 +0000
+++ src/com/goldencode/p2j/persist/DsTableDefinition.java	2022-11-11 11:52:54 +0000
@@ -2,7 +2,7 @@
 ** Module   : DsTableDefinition.java
 ** Abstract : A container for a DataSet Table metadata.
 **
-** Copyright (c) 2019-2021, Golden Code Development Corporation.
+** Copyright (c) 2019-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------------Description---------------------------------------
 ** 001 OM  20130708 Created initial version.
@@ -20,6 +20,8 @@
 **     OM  20210309 Do not use DmoMeta as key in TableMapper because temp-tables share the same DmoMeta.
 **     SVL 20210614 Added copyRows parameter.
 **     SVL 20210701 Added clearRows.
+**     IAS 20221108 Fixed support for SCHEMA-MARSHAL == NONE. Re-worked (de)serialization.
+**     IAS 20221111 Fixed 'schemaMarshalLevel', 'xmlNodeName', 'nsURI', and 'nsPrefix' support.
 */
 
 /*
@@ -79,6 +81,8 @@
 
 import java.io.*;
 import java.util.*;
+import java.util.stream.*;
+
 import com.goldencode.p2j.util.*;
 import static com.goldencode.p2j.persist.AbstractTempTable.*;
 import static com.goldencode.util.NativeTypeSerializer.*;
@@ -90,6 +94,9 @@
 public class DsTableDefinition
 implements Externalizable
 {
+   /** Flag indicating that table schema was received */  
+   boolean receivedSchema = false;
+
    /** The name of this table. */
    private String name;
    
@@ -126,6 +133,9 @@
    /** The ERROR-STRING attribute for this table definition. */
    private String errorString = null;
    
+   /** List of indexes' descriptors */
+   private List<IndexDefinition> indexDefs = null;
+
    /**
     * A string with all indexes of this table definition encoded as a {@code String}.
     * 
@@ -136,9 +146,9 @@
    
    /**
     * The SCHEMA-MARSHAL level for the serialized temp-table. It is never {@code SM_DEFAULT} when object is to
-    * be serialized. Always {@code SM_DEFAULT} for a read object.
+    * be serialized. 
     */
-   private final int schemaMarshalLevel;
+   private int schemaMarshalLevel;
    
    /**
     * Default c'tor, explicitly added to allow instances of this class to be created on 
@@ -186,23 +196,19 @@
       switch (sml)
       {
          case SM_FULL:
+         case SM_MIN:
+            this.errorString = defBuff.errorString().toStringMessage();
+            // no break, fall through
          case SM_DEFAULT:
             // full table schema is serialized with table parameter
+            character tmp = parentTable.namespaceURI(); 
+            this.xmlns = tmp.isUnknown() ? "" : tmp.toJavaType(); 
+            this.xmlPrefix = parentTable.namespacePrefix().toJavaType(); 
+            this.xmlNodeName = parentTable.namespacePrefix().toJavaType();
             this.indexes = TableMapper.getLegacyIndexInfo(parentTable);
             this.numIndexes = this.indexes.split("\\.").length;
-            this.xmlns = parentTable.namespaceURI().toStringMessage();
-            this.xmlPrefix = parentTable.namespacePrefix().toStringMessage();
-            this.xmlNodeName = parentTable.getXmlNodeName().toStringMessage();
-            // no break, fall through
-            
-         case SM_MIN:
-            // marshals:
-            //    field names, data types, and extents;
-            //    temp-table ERROR-STRING
-            // does NOT marshal:
-            //    index descriptions
-            //    field information (label, help, field validation expression, and so on (?))
-            this.errorString = defBuff.errorString().toStringMessage();
+            this.indexDefs = TableMapper.getLegacyIndexes(parentTable).map(lif -> new IndexDefinition(lif)).
+                     collect(Collectors.toList());
             // no break, fall through
          
          case SM_NONE:
@@ -267,6 +273,14 @@
    }
    
    /**
+    * The SCHEMA-MARSHAL level for the serialized temp-table. 
+    */
+   public int getSchemaMarshalLevel()
+   {
+      return schemaMarshalLevel;
+   }
+   
+   /**
     * Sets the name of this table.
     *
     * @param   name
@@ -277,6 +291,16 @@
       this.name = name;
    }
    
+   /** 
+    * Check that table schema was received.
+    * 
+    * @return <code>true</code> if table schema was received.
+    */
+   public boolean isReceivedSchema() 
+   {
+      return receivedSchema;
+   }
+
    /**
     * Check whether this is a definition of an AFTER-TABLE.
     * 
@@ -386,6 +410,15 @@
    }
    
    /**
+    * Get List of indexes' descriptors.
+    * @return the List of indexes' descriptors.
+    */
+   public List<IndexDefinition> getIndexDefs()
+   {
+      return indexDefs;
+   }
+
+   /**
     * Sets the XML namespace for this table definition.
     * 
     * @param   xmlns
@@ -502,7 +535,7 @@
                "A custom result set must not be specified when calling this method!");
       }
       
-      return new ArrayList<>(properties);
+      return properties != null ? new ArrayList<>(properties) : Collections.emptyList();
    }
    
    /**
@@ -562,39 +595,52 @@
    public final void writeExternal(ObjectOutput out)
    throws IOException
    {
+      boolean writeSchema = schemaMarshalLevel != SM_NONE;
+      out.writeByte(schemaMarshalLevel);
       writeString(out, name);
       out.writeByte(tableType);
-      out.writeByte(numIndexes);
-      writeString(out, indexes);
-      writeString(out, xmlns);
-      writeString(out, xmlPrefix);
-      writeString(out, xmlNodeName);
-      writeString(out, errorString);
-      
-      // write properties as a byte(1) separated list, ended with a byte(0)
-      Set<Integer> blobProps = null;
+      if (writeSchema)
+      {
+         out.writeByte(numIndexes);
+         writeString(out,indexes);
+         writeList(out, indexDefs);
+         writeString(out,xmlns);
+         writeString(out,xmlPrefix);
+      }
+
+      // write properties
+      Set<Integer> blobProps = new HashSet<>();
+      Set<Integer> objectProps = new HashSet<>();
       if (resultSet != null)
       {
          int idx = 0;
          while (resultSet.hasMoreProperties())
          {
             PropertyDefinition property = resultSet.nextProperty();
-            property.setMarshalLevel(schemaMarshalLevel);
-            out.writeByte(1);
-            property.writeExternal(out);
-            
+            if (writeSchema)
+            {
+               property.setMarshalLevel(schemaMarshalLevel);
+               out.writeByte(1);
+               property.writeExternal(out);
+            }
+
             if (property.getType() == blob.class)
             {
-               if (blobProps == null)
-               {
-                  blobProps = new HashSet<>();
-               }
                blobProps.add(idx);
             }
+            else if (object.class.isAssignableFrom(property.getType()))
+            {
+               objectProps.add(idx);
+            }
             idx = idx + 1;
          }
       }
-      out.writeByte(0);
+      if (writeSchema)
+      {
+         out.writeByte(0);
+      }
+      writeIntSet(out, blobProps);
+      writeIntSet(out, objectProps);
       
       // write data 
       if (resultSet != null)
@@ -647,40 +693,30 @@
    throws IOException,
           ClassNotFoundException
    {
+      schemaMarshalLevel = in.readByte(); 
+      receivedSchema = schemaMarshalLevel != SM_NONE;
       name = readString(in);
       tableType = in.readByte();
-      numIndexes = in.readByte();
-      indexes = readString(in);
-      xmlns = readString(in);
-      xmlPrefix = readString(in);
-      xmlNodeName = readString(in);
-      errorString = readString(in);
-      
-      // read meta info separated by byte(1). The list ends with a byte(0).
-      properties = new ArrayList<>();
-      Set<Integer> blobProps = null;
-      int idx = 0;
-      boolean moreProperties = (in.readByte() == 1); 
-      while (moreProperties) 
+      if (receivedSchema)
       {
-         PropertyDefinition pd = new PropertyDefinition();
-         pd.readExternal(in);
-         properties.add(pd);
-         
-         // check if there are more to read:
-         moreProperties = (in.readByte() == 1);
-
-         if (pd.getType() == blob.class)
+         numIndexes = in.readByte();
+         indexes = readString(in);
+         indexDefs = readList(in, () -> new IndexDefinition());
+         xmlns = readString(in);
+         xmlPrefix = readString(in);
+         properties = new ArrayList<>();
+         while (in.readByte() != 0)
          {
-            if (blobProps == null)
-            {
-               blobProps = new HashSet<>();
-            }
-            blobProps.add(idx);
+            PropertyDefinition pd = new PropertyDefinition();
+            pd.readExternal(in);
+            properties.add(pd);
+            
          }
-         idx = idx + 1;
       }
       
+      Set<Integer> blobProps = readIntSet(in);
+      Set<Integer> objectProps = readIntSet(in);
+      
       // read data
       rows = new ArrayList<>();
       rowsMeta = new ArrayList<>();

=== modified file 'src/com/goldencode/p2j/persist/DynamicTablesHelper.java'
--- src/com/goldencode/p2j/persist/DynamicTablesHelper.java	2022-10-14 12:38:17 +0000
+++ src/com/goldencode/p2j/persist/DynamicTablesHelper.java	2022-11-02 07:54:50 +0000
@@ -79,6 +79,7 @@
 **     OM  20220914 Use MAX-WIDTH to generate custom sized varchar columns.
 **     IAS 20221006 Added RAW type to the switch in the 'generateSchemaAst'.
 **     IAS 20221013 Fixed setting of "serialize-name" and "serialize-hidden annotations".
+**     IAS 20221014 Fixed 'column-codepage' support.
 */
 
 /*
@@ -831,10 +832,10 @@
          {
             tableField.putAnnotation("col_lab", field.getColumnLabel());
          }
-         
-         if (field.getCodePage() != null)
+         String cp = field.getCodePage();
+         if (cp != null && !cp.trim().equals(""))
          {
-            tableField.putAnnotation("codePage", field.getCodePage());
+            tableField.putAnnotation("column-codepage", cp);
          }
 
          if (field.isSerializeHidden())

